﻿Imports System.ComponentModel
Imports System.Runtime.CompilerServices

Public Class Person
    Implements INotifyPropertyChanged


    Private _firstname As String
    Public Property Firstname As String
        Get
            Return _firstname
        End Get
        Set(ByVal Value As String)
            _firstname = Value
            RaisePropertyChanged()
        End Set
    End Property

    Private _lastname As String
    Public Property Lastname As String
        Get
            Return _lastname
        End Get
        Set(ByVal Value As String)
            _lastname = Value
            RaisePropertyChanged()
        End Set
    End Property

    Private _birthday As Date
    Public Property Birthday As Date
        Get
            Return _birthday
        End Get
        Set(ByVal Value As Date)
            _birthday = Value
            RaisePropertyChanged()
        End Set
    End Property

    Private _credit As Decimal
    Public Property Credit As Decimal
        Get
            Return _credit
        End Get
        Set(ByVal Value As Decimal)
            _credit = Value
            RaisePropertyChanged()
        End Set
    End Property


    Protected Overridable Sub RaisePropertyChanged(<CallerMemberName> Optional ByVal prop As String = "")
        RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs(prop))
    End Sub

    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged
End Class
